﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace Combo_BindingIssue
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            this.DataContext = new ViewModel();
        }
    }

    public class CustomType
    {
        public string Name { get; set; }
        public bool Value { get; set; }


        public override string ToString()
        {
            return Name;
        }

        public static ObservableCollection<CustomType> GetCustomTypes()
        {
            return new ObservableCollection<CustomType>
      {
         new CustomType {Name = "CustomTypeA", Value = true},
         new CustomType {Name = "CustomTypeB", Value = false}                        
      };
        }
    }

    public class MyBusinessObject
    {
        public string Name { get; set; }
        public bool isTypeA;
        public bool IsTypeA
        {
            get
            {
                return isTypeA;
            }
            set
            {
                isTypeA = value;
            }
        }
        //Other properties and methods omitted for simplicity
    }

    public class ViewModel : INotifyPropertyChanged
    {
        private MyBusinessObject _selectedItem = new MyBusinessObject();
        
        public MyBusinessObject SelectedItem
        {
            get { return _selectedItem; }
            set { _selectedItem = value; this.OnPropertyChanged("SelectedItem"); }
        }

        private ObservableCollection<CustomType> _customTypes;
        public ObservableCollection<CustomType> CustomTypes
        {
            get { return _customTypes ?? (_customTypes = CustomType.GetCustomTypes()); }
        }


        private void OnPropertyChanged(string propName)// Expression<Func<PropertyChangedEventArgs>)
        {
            if (this.PropertyChanged != null)
            {
                this.PropertyChanged(this, new PropertyChangedEventArgs(propName));
            }
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion
    }
}